// Generic Callbacks
public delegate void Callback();
public delegate void Callback<T>(T arg);
public delegate void Callback<T, K>(T arg1, K arg2);

public delegate bool Validation<T>(T arg);
public delegate T Generator<T>();